=begin
#The ReliefWeb API

#Interactive API documentation for the data API of Reliefweb.int. ReliefWeb is a leading source of information on global crises and disasters.<br><br> Our continuous coverage and archive going back to the 1970s makes ReliefWeb an unparalleled resource for both current and historical data on humanitarian response.<br><br> The vast majority of content on ReliefWeb has been contributed by humanitarian partners. We owe it to the community to make data more accessible and reusable, so that developers can build tools that increase exposure for valuable content and facilitate analysis for better decisions.

OpenAPI spec version: v1
Contact: api@reliefweb.int
Generated by: https://github.com/swagger-api/swagger-codegen.git
Swagger Codegen version: 2.4.12

=end

# Common files
require 'reliefweb-api/api_client'
require 'reliefweb-api/api_error'
require 'reliefweb-api/version'
require 'reliefweb-api/configuration'

# Models
require 'reliefweb-api/models/category'
require 'reliefweb-api/models/country'
require 'reliefweb-api/models/date'
require 'reliefweb-api/models/disaster'
require 'reliefweb-api/models/error'
require 'reliefweb-api/models/error_definition'
require 'reliefweb-api/models/facets_field_post'
require 'reliefweb-api/models/facets_filter_post'
require 'reliefweb-api/models/facets_interval_post'
require 'reliefweb-api/models/facets_limit_post'
require 'reliefweb-api/models/facets_name_post'
require 'reliefweb-api/models/facets_sort_post'
require 'reliefweb-api/models/fields_exclude_post'
require 'reliefweb-api/models/fields_include_post'
require 'reliefweb-api/models/file'
require 'reliefweb-api/models/filter_conditions_post'
require 'reliefweb-api/models/filter_field_post'
require 'reliefweb-api/models/filter_negate_post'
require 'reliefweb-api/models/filter_operator_post'
require 'reliefweb-api/models/filter_value_post'
require 'reliefweb-api/models/job'
require 'reliefweb-api/models/language'
require 'reliefweb-api/models/limit_post'
require 'reliefweb-api/models/location'
require 'reliefweb-api/models/offset_post'
require 'reliefweb-api/models/post_params'
require 'reliefweb-api/models/preset_post'
require 'reliefweb-api/models/profile_post'
require 'reliefweb-api/models/query_fields_post'
require 'reliefweb-api/models/query_operator_post'
require 'reliefweb-api/models/query_value_post'
require 'reliefweb-api/models/report'
require 'reliefweb-api/models/sort_post'
require 'reliefweb-api/models/source'
require 'reliefweb-api/models/training'

# APIs
require 'reliefweb-api/api/countries_api'
require 'reliefweb-api/api/disasters_api'
require 'reliefweb-api/api/discovery_api'
require 'reliefweb-api/api/jobs_api'
require 'reliefweb-api/api/reports_api'
require 'reliefweb-api/api/sources_api'
require 'reliefweb-api/api/training_api'

module ReliefWebAPI
  class << self
    # Customize default settings for the SDK using block.
    #   ReliefWebAPI.configure do |config|
    #     config.username = "xxx"
    #     config.password = "xxx"
    #   end
    # If no block given, return the default Configuration object.
    def configure
      if block_given?
        yield(Configuration.default)
      else
        Configuration.default
      end
    end
  end
end
